//    AS-megaM
// 9  2003

#ifndef ASMEGAM
#define ASMEGAM

#include <iom128v.h>
#include <macros.h>

typedef unsigned char byte;
typedef unsigned short word;
typedef unsigned long dword;

// hw spi: sck=pb1, mosi=pb2, miso=pb3

#define PORTSPI		PORTB
#define PINSPI		PINB
#define DDRSPI		DDRB
#define SPI_SCK		BIT(1)
#define SPI_MOSI	BIT(2)
#define SPI_MISO	BIT(3)

// leds: led0=pd6, led1=pd7

#define PORTLED		PORTD
#define PINLED		PIND
#define DDRLED		DDRD
#define LED0		BIT(6)
#define LED1		BIT(7)

// lcd: data=porta, rs=pc6, pc5=wr, pe2=e

#define LCD_RS		BIT(6)
#define LCD_RW		BIT(5)
#define LCD_E		BIT(2)

// at45: cs=pb5, spi=spi

#define AT45_CS	 	BIT(5)

// dac: ldac=pb6, sync=pb7

#define PORTDAC		PORTB
#define PINDAC		PINB
#define DDRDAC		DDRB
#define DAC_LDAC	BIT(6)
#define DAC_SYNC	BIT(7)

#endif