//     AS-megaM
//     8-    

#ifndef LCD_H
#define LCD_H

#include "asmegam.h"

#define lcd_set_e()  (PORTE |= LCD_E)
#define lcd_set_rs() (PORTC |= LCD_RS)
#define lcd_set_rw() (PORTC |= LCD_RW)

#define lcd_clear_e()  (PORTE &= ~LCD_E)
#define lcd_clear_rs() (PORTC &= ~LCD_RS)
#define lcd_clear_rw() (PORTC &= ~LCD_RW)

void delay(dword ticks)
{ 
	while(ticks--)
		;
}

void lcd_pulse(void)
{
	delay(3);
	lcd_set_e();
	delay(30);
	lcd_clear_e();
	delay(30);
}

void lcd_wait(void)
{
	delay(500);
}

void lcd_send(byte data)
{
	delay(3);
	PORTA = data;  
	lcd_pulse();
}

void clrscr(void)
{      
	delay(10);
	lcd_clear_rs();
	delay(10);
	lcd_clear_rw();
	delay(10);
	lcd_send(0x01);
	lcd_wait();
}

void init_lcd(void)
{
	delay(3);
	DDRC |= (LCD_E | LCD_RS | LCD_RW);
	DDRE |= (LCD_E);
	DDRA = 0xFF;
	delay(3);
	lcd_clear_rw();
	lcd_clear_rs();
	lcd_wait(); 
	lcd_send(0x3C); 
	lcd_wait(); 
	lcd_send(0x3C);
	lcd_wait(); 
	lcd_send(0x3C);
	lcd_wait(); 
	lcd_send(0x06);
	lcd_wait(); 
	lcd_send(0x0C);
	lcd_wait(); 
	lcd_send(0x01);
	lcd_wait(); 
}    

void gotoz(byte z)
{
	delay(3);
	lcd_clear_rw();
	delay(3);
	lcd_clear_rs();
	delay(3);
	lcd_send(z | 0x80);
}

#define gotoxy(x,y) gotoz(x|(y<<6))

void putchar(char c)
{
	delay(3);
	lcd_clear_rw();
	delay(3);
	lcd_set_rs();
	delay(3);
	lcd_send(c);
}

void outtexts(const char* s)
{
	unsigned char i = 0;
	while(s[i])
	{
		putchar(s[i]);
		i++;
	}
}

void outtext(char* s)
{
	unsigned char i = 0;
	while(s[i])
	{
		putchar(s[i]);
		i++;
	}
}

#endif