;CodeVisionAVR C Compiler V1.24.2c Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega128
;Program type        : Application
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 1024 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : No
;Enhanced core instructions    : On
;Automatic register allocation : On

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F
	.EQU XMCRA=0x6D
	.EQU XMCRB=0x6C

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x20
	.EQU __sm_mask=0x1C
	.EQU __sm_adc_noise_red=0x08
	.EQU __sm_powerdown=0x10
	.EQU __sm_powersave=0x18
	.EQU __sm_standby=0x14
	.EQU __sm_ext_standby=0x1C

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "memtest.vec"
	.INCLUDE "memtest.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  MCUCR,R31
	OUT  MCUCR,R30
	STS  XMCRB,R30
	OUT  RAMPZ,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x1000)
	LDI  R25,HIGH(0x1000)
	LDI  R26,LOW(0x100)
	LDI  R27,HIGH(0x100)
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x10FF)
	OUT  SPL,R30
	LDI  R30,HIGH(0x10FF)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x500)
	LDI  R29,HIGH(0x500)

	JMP  _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0x500
;       1 #include "asmegam.h"
;       2 #include "lcd.h"

	.CSEG
_delay:
_0x3:
	__GETD1S 0
	SBIW R30,1
	SBCI R22,0
	SBCI R23,0
	__PUTD1S 0
	__SUBD1N -1
	BRNE _0x3
	ADIW R28,4
	RET
_lcd_pulse:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	COM  R30
	COM  R31
	RCALL SUBOPT_0x1
	RET
_lcd_wait:
	__GETD1N 0x1F4
	CALL __PUTPARD1
	RCALL _delay
	RET
_lcd_send:
	RCALL SUBOPT_0x0
	LD   R30,Y
	RCALL _lcd_pulse
	RJMP _0x23
_clrscr:
	RCALL SUBOPT_0x2
	LDI  R30,LOW(6)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x2
	LDI  R30,LOW(5)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__GETD1N 0xA
	CALL __PUTPARD1
	RCALL _delay
	RCALL SUBOPT_0x3
	RET
_init_lcd:
	RCALL SUBOPT_0x0
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x4
	LDI  R30,LOW(5)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDI  R30,LOW(2)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDI  R30,LOW(255)
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x7
	RCALL _lcd_wait
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x8
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x8
	RCALL SUBOPT_0x3
	RET
_gotoz:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x6
	RCALL SUBOPT_0x0
	LD   R30,Y
	ORI  R30,0x80
	ST   -Y,R30
	RCALL _lcd_send
	RJMP _0x23
_putchar:
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x5
	RCALL SUBOPT_0x0
	LDI  R30,LOW(6)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RCALL SUBOPT_0x0
	LD   R30,Y
	ST   -Y,R30
	RCALL _lcd_send
_0x23:
	ADIW R28,1
	RET
;	*s -> Y+1
;	i -> R16
_outtext:
	ST   -Y,R16
;	*s -> Y+1
;	i -> R16
	LDI  R16,0
_0x9:
	RCALL SUBOPT_0x9
	CPI  R30,0
	BREQ _0xB
	RCALL SUBOPT_0x9
	ST   -Y,R30
	RCALL _putchar
	SUBI R16,-1
	RJMP _0x9
_0xB:
	LDD  R16,Y+0
	RJMP _0x21
;       3 
;       4 void port_init(void)
;       5 {
_port_init:
;       6 	DDRD |= (LED0 | LED1);
	LDI  R30,LOW(6)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDI  R30,LOW(7)
;       7 	PORTD |= (LED0 | LED1);
	RCALL SUBOPT_0x4
	LDI  R30,LOW(7)
;       8 
;       9 	PORTC = 0;
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;      10 }
	RET
;      11 
;      12 void timer0_init(void)
;      13 {
;      14 	TCCR0 = 0x00;
;      15 	ASSR  = 0x08;
;      16 	TCNT0 = 0x00;
;      17 	TCCR0 = 0x04;
;      18 }
;      19 
;      20 // hw mode
;      21 
;      22 void mem_init()
;      23 {
_mem_init:
;      24 	PORTA = 0x00;
	LDI  R30,LOW(0)
;      25 	PORTC = 0x00;
;      26 	PORTG = 3; // rd|wr
	LDI  R30,LOW(3)
;      27 	DDRA = 0xff;
	LDI  R30,LOW(255)
;      28 	DDRC = 0xff;
;      29 	DDRG |= 7;
	LDI  R30,LOW(7)
;      30 
;      31 	MCUCR |= (1<<7) | (1<<6); // sram enable, sram wait state
	LDI  R30,LOW(192)
;      32 	XMCRA = (1<<3) | (1<<2); // all lower section, max. waitstates
	LDI  R30,LOW(12)
;      33 	XMCRB = (1<<7) | (1<<0); // bus keeper + release pc7
	LDI  R30,LOW(129)
;      34 }
	RET
;      35 
;      36 void mem_deinit()
;      37 {
_mem_deinit:
;      38 	MCUCR &= ~((1<<7) | (1<<6)); // sram enable, sram wait state
;      39 	XMCRA &= ~((1<<3) | (1<<2)); // all lower section, max. waitstates
;      40 	XMCRB &= ~((1<<7) | (1<<0)); // bus keeper + release pc7
;      41 }
	RET
;      42 
;      43 volatile byte *mem = ((volatile unsigned char *)0x0000);

	.DSEG
_mem:
	.BYTE 0x2

	.CSEG
;      44 
;      45 void mem_write(word a, byte d)
;      46 {
_mem_write:
;      47 	mem[a] = d;
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	LDS  R26,_mem
	LDS  R27,_mem+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,Y
	ST   X,R30
;      48 }
	RJMP _0x21
;      49 
;      50 byte mem_read(word a)
;      51 {
_mem_read:
;      52 	return mem[a];
	LD   R30,Y
	LDD  R31,Y+1
	LDS  R26,_mem
	LDS  R27,_mem+1
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RJMP _0x22
;      53 }
;      54 
;      55 byte hex[16] = "0123456789abcdef";

	.DSEG
_hex:
	.BYTE 0x10
;      56 
;      57 void puthexbyte(byte a)
;      58 {

	.CSEG
;      59 	putchar(hex[a>>4]);
;      60 	putchar(hex[a&15]);
;      61 }
;      62 
;      63 void puthexword(word a)
;      64 {
_puthexword:
;      65 	putchar(hex[(a>>12)%15]);
	LD   R26,Y
	LDD  R27,Y+1
	LDI  R30,LOW(12)
	CALL __LSRW12
	RCALL SUBOPT_0xA
;      66 	putchar(hex[(a>>8)%15]);
	LDD  R30,Y+1
	ANDI R31,HIGH(0x0)
	RCALL SUBOPT_0xA
;      67 	putchar(hex[(a>>4)%15]);
	LD   R30,Y
	LDD  R31,Y+1
	CALL __LSRW4
	RCALL SUBOPT_0xA
;      68 	putchar(hex[a&15]);
	LD   R30,Y
	LDD  R31,Y+1
	ANDI R30,LOW(0xF)
	ANDI R31,HIGH(0xF)
	SUBI R30,LOW(-_hex)
	SBCI R31,HIGH(-_hex)
	LD   R30,Z
	ST   -Y,R30
	RCALL _putchar
;      69 }
_0x22:
	ADIW R28,2
	RET
;      70 
;      71 byte f(word i, byte t)
;      72 {
_f:
;      73 	if(t == 0)
	LD   R30,Y
	CPI  R30,0
	BRNE _0xC
;      74 		return 0;
	LDI  R30,LOW(0)
	RJMP _0x21
;      75 	else if(t == 1)
_0xC:
	LD   R26,Y
	CPI  R26,LOW(0x1)
	BRNE _0xE
;      76 		return 0xff;
	LDI  R30,LOW(255)
	RJMP _0x21
;      77 	else 
_0xE:
;      78 		return (i>>(t-2))&0xff;
	LD   R30,Y
	SUBI R30,LOW(2)
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R31,0
	CALL __LSRW12
	ANDI R31,HIGH(0xFF)
;      79 }
_0x21:
	ADIW R28,3
	RET
;      80 
;      81 void main(void) //  
;      82 {
_main:
;      83 	word i,t;
;      84 	byte ok;
;      85 
;      86 	CLI(); //   
;	i -> R16,R17
;	t -> R18,R19
;	ok -> R20
;      87 	XDIV  = 0x00; //  . ICCAVR AppBuilder
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
;      88 	XMCRA = 0x0A; //external memory
	LDI  R30,LOW(10)
;      89 	XMCRB = 0x00;
	LDI  R30,LOW(0)
;      90 	port_init();
	RCALL _port_init
;      91 	MCUCR = 0x00;
	LDI  R30,LOW(0)
;      92 	EICRA = 0x00;
;      93 	EICRB = 0x00;
;      94 	EIMSK = 0x00;
;      95 	TIMSK = 0x01;
	LDI  R30,LOW(1)
;      96 	ETIMSK = 0x00;
	LDI  R30,LOW(0)
;      97 		
;      98 	init_lcd(); //    
	RCALL _init_lcd
;      99 
;     100 	gotoxy(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _gotoz
;     101 	outtext("Testing...");
	__POINTW1FN _0,17
	RCALL SUBOPT_0xB
;     102 
;     103 	gotoxy(0,1);
;     104 	outtext("Pass ");
	__POINTW1FN _0,28
	ST   -Y,R31
	ST   -Y,R30
	RCALL _outtext
;     105 
;     106 	ok = 1;
	LDI  R20,LOW(1)
;     107 
;     108 	for(t = 0; t < 8 && ok; t++)
	__GETWRN 18,19,0
_0x11:
	__CPWRN 18,19,8
	BRSH _0x13
	CPI  R20,0
	BRNE _0x14
_0x13:
	RJMP _0x12
_0x14:
;     109 	{
;     110 		putchar(t+'A');
	RCALL SUBOPT_0xC
;     111 
;     112 		mem_init();
	RCALL _mem_init
;     113 	
;     114 		for(i = 0x1100; i < 0x8000; i++)
	__GETWRN 16,17,4352
_0x16:
	__CPWRN 16,17,32768
	BRSH _0x17
;     115 			mem_write(i,f(i,t));
	ST   -Y,R17
	ST   -Y,R16
	RCALL SUBOPT_0xD
	ST   -Y,R30
	RCALL _mem_write
	__ADDWRN 16,17,1
	RJMP _0x16
_0x17:
;     116 
;     117 		for(i = 0x1100; i < 0x8000 && ok; i++)
	__GETWRN 16,17,4352
_0x19:
	__CPWRN 16,17,32768
	BRSH _0x1B
	CPI  R20,0
	BRNE _0x1C
_0x1B:
	RJMP _0x1A
_0x1C:
;     118 			if(mem_read(i) != f(i,t))
	ST   -Y,R17
	ST   -Y,R16
	RCALL _mem_read
	PUSH R30
	RCALL SUBOPT_0xD
	POP  R26
	CP   R30,R26
	BREQ _0x1D
;     119 				ok = 0;
	LDI  R20,LOW(0)
;     120 	
;     121 		mem_deinit();
_0x1D:
	__ADDWRN 16,17,1
	RJMP _0x19
_0x1A:
	RCALL _mem_deinit
;     122 	}
	__ADDWRN 18,19,1
	RJMP _0x11
_0x12:
;     123 
;     124 	clrscr();
	RCALL _clrscr
;     125 
;     126 	if(ok)
	CPI  R20,0
	BREQ _0x1E
;     127 		outtext("SRAM present");
	__POINTW1FN _0,34
	ST   -Y,R31
	ST   -Y,R30
	RCALL _outtext
;     128 	else
	RJMP _0x1F
_0x1E:
;     129 	{
;     130 		outtext("SRAM not present");
	__POINTW1FN _0,47
	RCALL SUBOPT_0xB
;     131 		gotoxy(0,1);
;     132 		outtext("Test=");
	__POINTW1FN _0,64
	ST   -Y,R31
	ST   -Y,R30
	RCALL _outtext
;     133 		putchar(t+'A');
	RCALL SUBOPT_0xC
;     134 		outtext(" Addr=");
	__POINTW1FN _0,70
	ST   -Y,R31
	ST   -Y,R30
	RCALL _outtext
;     135 		puthexword(i);
	ST   -Y,R17
	ST   -Y,R16
	RCALL _puthexword
;     136 	}
_0x1F:
;     137 }
_0x20:
	RJMP _0x20

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x0:
	__GETD1N 0x3
	CALL __PUTPARD1
	RJMP _delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	LDI  R30,LOW(2)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	__GETD1N 0x1E
	CALL __PUTPARD1
	RJMP _delay

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x2:
	__GETD1N 0xA
	CALL __PUTPARD1
	RCALL _delay
	COM  R30
	COM  R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _lcd_send
	RJMP _lcd_wait

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x4:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	LDI  R30,LOW(6)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x5:
	COM  R30
	COM  R31
	LDI  R30,LOW(5)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	COM  R30
	COM  R31
	LDI  R30,LOW(6)
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x7:
	RCALL _lcd_wait
	LDI  R30,LOW(60)
	ST   -Y,R30
	RJMP _lcd_send

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	ST   -Y,R30
	RCALL _lcd_send
	RJMP _lcd_wait

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	MOV  R30,R16
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R31,0
	ADD  R26,R30
	ADC  R27,R31
	LD   R30,X
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0xA:
	MOVW R26,R30
	LDI  R30,LOW(15)
	LDI  R31,HIGH(15)
	CALL __MODW21U
	SUBI R30,LOW(-_hex)
	SBCI R31,HIGH(-_hex)
	LD   R30,Z
	ST   -Y,R30
	RJMP _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	RCALL _outtext
	LDI  R30,LOW(64)
	ST   -Y,R30
	RJMP _gotoz

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	__GETW1R 18,19
	SUBI R30,LOW(-65)
	SBCI R31,HIGH(-65)
	ST   -Y,R30
	RJMP _putchar

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	ST   -Y,R17
	ST   -Y,R16
	__GETW1R 18,19
	ST   -Y,R30
	RJMP _f

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSRW4:
	LSR  R31
	ROR  R30
__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

