;CodeVisionAVR C Compiler V1.24.2c Standard
;(C) Copyright 1998-2004 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90LS8535
;Clock frequency     : 3,680000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "main.vec"
	.INCLUDE "main.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*         
;       2 
;       3   - AVR -  -   avr123.nm.ru
;       4 
;       5    AVR335 atmel          gaw.ru
;       6  
;       7     .
;       8 
;       9 ==================
;      10 
;      11 last_byte_position_buffer    last_byte_page 
;      12      
;      13         
;      14 
;      15      FLASH  at45db161 
;      16    at90s8535     
;      17 
;      18   498  , 
;      19  12,2 %     
;      20 
;      21 
;      22   :
;      23 
;      24 1.    
;      25 
;      26 2.  5  
;      27 
;      28 0 1 2 ... 254 255 0 1 2 ....
;      29 
;      30 3.      rs232   
;      31 
;      32    (528 ) 
;      33   8 : NextPg.
;      34 
;      35      main .
;      36 
;      37  UART  115200   
;      38  3.68     (  "" - "" )
;      39  
;      40 */
;      41      
;      42 
;      43 // I/O register definitions for AT90S8535
;      44 #include <90s8535.h>
;      45 
;      46 #include <at45d161.h> 
_new_data:
	.BYTE 0x1
_dumb_data:
	.BYTE 0x1
_flash_filed:
	.BYTE 0x1

	.CSEG
_erasing:
	RCALL __SAVELOCR3
;	block_counter -> R16,R17
;	temp -> R18
	LDI  R16,0
	LDI  R17,0
	LDI  R18,128
	LDI  R30,LOW(1)
	STS  _new_data,R30
	RCALL SUBOPT_0x0
_0x3:
	__CPWRN 16,17,512
	BRSH _0x5
	CBI  0x18,4
	LDI  R30,LOW(80)
	OUT  0xF,R30
_0x6:
	RCALL SUBOPT_0x1
	BREQ _0x6
	__GETW1R 16,17
	RCALL __LSRW3
	OUT  0xF,R30
_0x9:
	RCALL SUBOPT_0x1
	BREQ _0x9
	__GETW2R 16,17
	LDI  R30,LOW(5)
	RCALL __LSLW12
	OUT  0xF,R30
_0xC:
	RCALL SUBOPT_0x1
	BREQ _0xC
	RCALL SUBOPT_0x2
_0xF:
	RCALL SUBOPT_0x1
	BREQ _0xF
	SBI  0x18,4
	__ADDWRN 16,17,1
_0x12:
	SBIS 0x16,1
	RJMP _0x12
	RJMP _0x3
_0x5:
	RCALL SUBOPT_0x3
	RJMP _0x74
_write_to_flash:

	.DSEG

	.CSEG

	.DSEG

	.CSEG
	ST   -Y,R16
;	flash_data -> Y+1
;	temp -> R16
	LDI  R16,128
	RCALL SUBOPT_0x0
	LDS  R30,_new_data
	CPI  R30,0
	BREQ _0x15
	CLR  R8
	CLR  R9
	CLR  R10
	CLR  R11
	LDI  R30,LOW(0)
	STS  _new_data,R30
_0x15:
_0x16:
	SBIS 0x16,1
	RJMP _0x16
	CBI  0x18,4
	LDI  R30,LOW(132)
	OUT  0xF,R30
_0x19:
	RCALL SUBOPT_0x4
	BREQ _0x19
	RCALL SUBOPT_0x2
_0x1C:
	RCALL SUBOPT_0x4
	BREQ _0x1C
	MOV  R30,R9
	ANDI R31,HIGH(0x0)
	OUT  0xF,R30
_0x1F:
	RCALL SUBOPT_0x4
	BREQ _0x1F
	OUT  0xF,R8
_0x22:
	RCALL SUBOPT_0x4
	BREQ _0x22
	LDD  R30,Y+1
	OUT  0xF,R30
_0x25:
	RCALL SUBOPT_0x4
	BREQ _0x25
	SBI  0x18,4
	__MOVEWRR 4,5,8,9
	__GETW1R 8,9
	ADIW R30,1
	__PUTW1R 8,9
	LDI  R30,LOW(527)
	LDI  R31,HIGH(527)
	CP   R30,R8
	CPC  R31,R9
	BRSH _0x28
	CLR  R8
	CLR  R9
	LDI  R30,LOW(4096)
	LDI  R31,HIGH(4096)
	CP   R10,R30
	CPC  R11,R31
	BRSH _0x29
	CBI  0x18,4
	LDI  R30,LOW(136)
	OUT  0xF,R30
_0x2A:
	RCALL SUBOPT_0x4
	BREQ _0x2A
	__GETW2R 10,11
	RCALL SUBOPT_0x5
_0x2D:
	RCALL SUBOPT_0x4
	BREQ _0x2D
	__GETW1R 10,11
	RCALL SUBOPT_0x6
_0x30:
	RCALL SUBOPT_0x4
	BREQ _0x30
	RCALL SUBOPT_0x2
_0x33:
	RCALL SUBOPT_0x4
	BREQ _0x33
	SBI  0x18,4
	__MOVEWRR 6,7,10,11
	__GETW1R 10,11
	ADIW R30,1
	__PUTW1R 10,11
	RJMP _0x36
_0x29:
	LDI  R30,LOW(1)
	STS  _flash_filed,R30
_0x36:
_0x28:
	LDD  R16,Y+0
	ADIW R28,2
	RET
_playback:
	RCALL __SAVELOCR3
;	page_counter -> R16,R17
;	active_buffer -> R18
	LDI  R16,0
	LDI  R17,0
	LDI  R18,1
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x7
_0x37:
	SBIS 0x16,1
	RJMP _0x37
_0x3A:
	__CPWRN 16,17,4095
	BRSH _0x3C
	__ADDWRN 16,17,1
	CPI  R18,1
	BRNE _0x3D
	SUBI R18,-1
	RJMP _0x3E
_0x3D:
	SUBI R18,1
_0x3E:
	RCALL SUBOPT_0x7
	ST   -Y,R18
	RCALL _active_buffer_to_UART
	RJMP _0x3A
_0x3C:
	RCALL SUBOPT_0x3
_0x74:
	RCALL __LOADLOCR3
	ADIW R28,3
	RET
_next_page_to_next_buffer:
	ST   -Y,R16
;	active_buffer -> Y+3
;	page_counter -> Y+1
;	temp -> R16
	LDI  R16,128
_0x3F:
	SBIS 0x16,1
	RJMP _0x3F
	CBI  0x18,4
	RCALL SUBOPT_0x8
	BRNE _0x42
	LDI  R30,LOW(85)
	RJMP _0x75
_0x42:
	LDI  R30,LOW(83)
_0x75:
	OUT  0xF,R30
_0x44:
	RCALL SUBOPT_0x4
	BREQ _0x44
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	RCALL SUBOPT_0x5
_0x47:
	RCALL SUBOPT_0x4
	BREQ _0x47
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	RCALL SUBOPT_0x6
_0x4A:
	RCALL SUBOPT_0x4
	BREQ _0x4A
	RCALL SUBOPT_0x2
_0x4D:
	RCALL SUBOPT_0x4
	BREQ _0x4D
	SBI  0x18,4
	LDD  R16,Y+0
	ADIW R28,4
	RET
_active_buffer_to_UART:
	RCALL __SAVELOCR3
;	active_buffer -> Y+3
;	buffer_counter -> R16,R17
;	temp -> R18
	LDI  R16,0
	LDI  R17,0
	LDI  R18,128
	__POINTW1FN _0,0
	ST   -Y,R31
	ST   -Y,R30
	RCALL _putsf
	CBI  0x18,4
	RCALL SUBOPT_0x8
	BRNE _0x50
	LDI  R30,LOW(84)
	RJMP _0x76
_0x50:
	LDI  R30,LOW(86)
_0x76:
	OUT  0xF,R30
_0x52:
	RCALL SUBOPT_0x1
	BREQ _0x52
	RCALL SUBOPT_0x2
_0x55:
	RCALL SUBOPT_0x1
	BREQ _0x55
	RCALL SUBOPT_0x2
_0x58:
	RCALL SUBOPT_0x1
	BREQ _0x58
	RCALL SUBOPT_0x2
_0x5B:
	RCALL SUBOPT_0x1
	BREQ _0x5B
	RCALL SUBOPT_0x2
_0x5E:
	RCALL SUBOPT_0x1
	BREQ _0x5E
_0x61:
	__CPWRN 16,17,528
	BRSH _0x63
	LDI  R30,LOW(255)
	OUT  0xF,R30
_0x64:
	RCALL SUBOPT_0x1
	BREQ _0x64
_0x67:
	SBIS 0xB,5
	RJMP _0x67
	IN   R30,0xF
	OUT  0xC,R30
	__ADDWRN 16,17,1
	RJMP _0x61
_0x63:
	SBI  0x18,4
	RCALL __LOADLOCR3
	ADIW R28,4
	RET
;      47 
;      48 // Standard Input/Output functions
;      49 #include <stdio.h>
;      50 
;      51 // delay functions
;      52 #include <delay.h>  
;      53                      
;      54 
;      55 
;      56 //  
;      57 
;      58 
;      59 // 
;      60 
;      61 void setup(void)  //   
;      62 {   
_setup:
;      63       DDRB = 0xB5;  // SPI Port initialisation  1011 0101
	LDI  R30,LOW(181)
	OUT  0x17,R30
;      64       
;      65       // SCK    SO      SI      CS                   RDY/BSY                     
;      66       // PB7    PB6     PB5     PB4     PB3    PB2     PB1      PB0             
;      67       //                 
;      68       // Out    In      Out     Out     In     Out     In       Out                  
;      69       //  1      0       1       1       1      1       0        1         
;      70     
;      71 /*
;      72     
;      73     PB1 - RDY      0x02
;      74     PB4 - CS    DF_CHIP_SELECT
;      75     
;      76 */
;      77                                             
;      78     PORTB = 0xFF; // all outputs high, inputs have pullups  
	LDI  R30,LOW(255)
	OUT  0x18,R30
;      79      
;      80     //  2 :
;      81     DDRA = 0x00;  // define port A as an input    
	LDI  R30,LOW(0)
	OUT  0x1A,R30
;      82     DDRA.4 = 1;  // define PA4 out for RED LED.   
	SBI  0x1A,4
;      83     DDRA.5 = 1;  // define PA5 out for GREEN LED.
	SBI  0x1A,5
;      84     
;      85     PORTA = 0x00;
	OUT  0x1B,R30
;      86 	 
;      87 	DDRC = 0;    
	OUT  0x14,R30
;      88  	PORTC = 0;
	OUT  0x15,R30
;      89  	
;      90  	DDRD = 0;    
	OUT  0x11,R30
;      91  	PORTD = 0; 
	OUT  0x12,R30
;      92  	
;      93 //////////////////////////////////////////////////////
;      94 // UART initialization
;      95 // Communication Parameters: 8 Data, 1 Stop, No Parity
;      96 
;      97 // UART Receiver: Off
;      98 // UART Transmitter: On
;      99 // UART Baud rate: 115200
;     100 
;     101 UCR=0x00;
	OUT  0xA,R30
;     102 UBRR=0x01;
	LDI  R30,LOW(1)
	OUT  0x9,R30
;     103 UCR=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
;     104 
;     105 /*      rs232
;     106 
;     107 while (!USR.5); //    UDR
;     108 
;     109 //  UART Status Register:  USR     AT90S/LS8535  p.62
;     110 
;     111 //  5   "1"    UDR   
;     112 //   .
;     113 
;     114 //  USR.5==1       UDR.
;     115 
;     116 //  5   0    UDR. 
;     117 
;     118 UDR = data_out; //      UART
;     119 
;     120 */ 
;     121 
;     122     #asm("sei") //   	 
	sei
;     123     	  
;     124 } 
	RET
;     125 
;     126 
;     127 
;     128 
;     129 
;     130 //  
;     131 
;     132 void main(void)
;     133 {     
_main:
;     134     unsigned int ctr = 0;
;     135     
;     136     setup();  
;	ctr -> R16,R17
	LDI  R16,0
	LDI  R17,0
	RCALL _setup
;     137     
;     138     PORTA.4=0;
	CBI  0x1B,4
;     139     PORTA.5=0;
	CBI  0x1B,5
;     140     //    
;     141     delay_ms(2000);
	RCALL SUBOPT_0x9
;     142     //  2 .
;     143     
;     144     PORTA.4=1;
	SBI  0x1B,4
;     145     PORTA.5=1;
	SBI  0x1B,5
;     146     //   
;     147     
;     148     delay_ms(2000);
	RCALL SUBOPT_0x9
;     149     //  2 .  
;     150     
;     151     
;     152     PORTA.5=0; //      
	CBI  0x1B,5
;     153     
;     154     erasing(); //  
	RCALL _erasing
;     155     
;     156      
;     157     PORTA.4=1;
	SBI  0x1B,4
;     158     PORTA.5=1;
	SBI  0x1B,5
;     159     //   
;     160     
;     161     delay_ms(2000);
	RCALL SUBOPT_0x9
;     162     //  2 .
;     163     
;     164     PORTA.4=0; //       
	CBI  0x1B,4
;     165     
;     166     //  5 .  last_byte_page 
;     167     //  4,  .
;     168     //    0 1 2 3 4  -  5.
;     169     
;     170     while (last_byte_page < 4)  
_0x6A:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	CP   R6,R30
	CPC  R7,R31
	BRSH _0x6C
;     171     {
;     172     dumb_data = 0;
	LDI  R30,LOW(0)
	STS  _dumb_data,R30
;     173     ctr = 0;
	__GETWRN 16,17,0
;     174     
;     175     	while (ctr<528)
_0x6D:
	__CPWRN 16,17,528
	BRSH _0x6F
;     176     	{
;     177      	write_to_flash(dumb_data);
	LDS  R30,_dumb_data
	ST   -Y,R30
	RCALL _write_to_flash
;     178      	dumb_data++;  
	LDS  R30,_dumb_data
	SUBI R30,-LOW(1)
	STS  _dumb_data,R30
;     179      	ctr++;
	__ADDWRN 16,17,1
;     180     	}
	RJMP _0x6D
_0x6F:
;     181        
;     182     }  
	RJMP _0x6A
_0x6C:
;     183          
;     184     
;     185     PORTA.4 = 1; //      
	SBI  0x1B,4
;     186     
;     187     delay_ms(2000); //  2 
	RCALL SUBOPT_0x9
;     188     
;     189    
;     190     PORTA.5=0; //       
	CBI  0x1B,5
;     191     
;     192     playback(); 
	RCALL _playback
;     193     //       
;     194     
;     195     /*
;     196       5   528    
;     197     0 1 2 ... 254 255 0 1 2 ....
;     198       
;     199          
;     200         255 
;     201     
;     202           8 
;     203     :  Next p.
;     204     
;     205     //   ,    
;     206     //          
;     207     */
;     208     
;     209     PORTA.5 = 1; 
	SBI  0x1B,5
;     210     //    
;     211 
;     212    
;     213     for(;;); 
_0x71:
	RJMP _0x71
;     214     //  ?      
;     215     
;     216 } 
_0x73:
	RJMP _0x73
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	LDI  R30,LOW(92)
	OUT  0xD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES
SUBOPT_0x1:
	IN   R30,0xE
	AND  R30,R18
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x2:
	LDI  R30,LOW(0)
	OUT  0xF,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	LDI  R30,LOW(0)
	OUT  0xD,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 13 TIMES
SUBOPT_0x4:
	IN   R30,0xE
	AND  R30,R16
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x5:
	LDI  R30,LOW(6)
	RCALL __LSRW12
	OUT  0xF,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	RCALL __LSLW2
	OUT  0xF,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	ST   -Y,R18
	ST   -Y,R17
	ST   -Y,R16
	RJMP _next_page_to_next_buffer

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDD  R26,Y+3
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(2000)
	LDI  R31,HIGH(2000)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

_putsf:
	ld   r30,y+
	ld   r31,y+
__putsf0:
	lpm 
	tst  r0
	breq __putsf1
	adiw r30,1
	push r30
	push r31
	rcall __putsf2
	pop  r31
	pop  r30
	rjmp __putsf0
__putsf1:
	ldi  r22,10
	mov  r0,r22
__putsf2:
	st   -y,r0
	rjmp _putchar

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x398
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__LSLW12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	MOV  R31,R27
	BREQ __LSLW12R
__LSLW12L:
	LSL  R30
	ROL  R31
	DEC  R0
	BRNE __LSLW12L
__LSLW12R:
	RET

__LSRW12:
	TST  R30
	MOV  R0,R30
	MOV  R30,R26
	MOV  R31,R27
	BREQ __LSRW12R
__LSRW12L:
	LSR  R31
	ROR  R30
	DEC  R0
	BRNE __LSRW12L
__LSRW12R:
	RET

__LSLW2:
	LSL  R30
	ROL  R31
	LSL  R30
	ROL  R31
	RET

__LSRW3:
	LSR  R31
	ROR  R30
__LSRW2:
	LSR  R31
	ROR  R30
	LSR  R31
	ROR  R30
	RET

__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

